<?php
namespace nur\sery\schema\input;

#XXX implémenter le renommage de paramètres et faire des méthodes pour
# construire des querystring et paramètres de formulaires
/**
 * Class FormInput: accès à des paramètres de formulaire (POST ou GET, dans cet
 * ordre)
 *
 * cette implémentation lit depuis les paramètres de formulaire et écrit dans
 * une référence
 *
 */
class FormInput extends Input {
  const ALLOW_EMPTY = false;

  function isPresent($key=null): bool {
    if ($key === null) return false;
    return array_key_exists($key, $_POST) || array_key_exists($key, $_GET);
  }

  function isAvailable($key=null): bool {
    if ($key === null) return false;
    if (array_key_exists($key, $_POST)) {
      return $this->allowEmpty || $_POST[$key] !== "";
    } elseif (array_key_exists($key, $_GET)) {
      return $this->allowEmpty || $_GET[$key] !== "";
    } else {
      return false;
    }
  }

  function get($key=null) {
    if ($key === null) return null;
    if (array_key_exists($key, $_POST)) {
      $value = $_POST[$key];
      if ($value === "" && !$this->allowEmpty) return null;
      return $value;
    } elseif (array_key_exists($key, $_GET)) {
      $value = $_GET[$key];
      if ($value === "" && !$this->allowEmpty) return null;
      return $value;
    } else {
      return null;
    }
  }
}
